"use strict";
// Copyright (c) Microsoft Corporation. All rights reserved. Licensed under the MIT license.
// See LICENSE in the project root for license information.
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.RushPluginsConfiguration = void 0;
const node_core_library_1 = require("@rushstack/node-core-library");
const rush_plugins_schema_json_1 = __importDefault(require("../schemas/rush-plugins.schema.json"));
class RushPluginsConfiguration {
    constructor(jsonFilename) {
        this._jsonFilename = jsonFilename;
        this.configuration = {
            plugins: []
        };
        if (node_core_library_1.FileSystem.exists(this._jsonFilename)) {
            this.configuration = node_core_library_1.JsonFile.loadAndValidate(this._jsonFilename, RushPluginsConfiguration._jsonSchema);
        }
    }
}
exports.RushPluginsConfiguration = RushPluginsConfiguration;
RushPluginsConfiguration._jsonSchema = node_core_library_1.JsonSchema.fromLoadedObject(rush_plugins_schema_json_1.default);
//# sourceMappingURL=RushPluginsConfiguration.js.map