"use strict";
// Copyright (c) Microsoft Corporation. All rights reserved. Licensed under the MIT license.
// See LICENSE in the project root for license information.
Object.defineProperty(exports, "__esModule", { value: true });
exports.SaveCallbackPackageJsonEditor = void 0;
const PackageJsonEditor_1 = require("./PackageJsonEditor");
class SaveCallbackPackageJsonEditor extends PackageJsonEditor_1.PackageJsonEditor {
    constructor(options) {
        super(options.filename, options.object);
        this._onSaved = options.onSaved;
    }
    static fromObjectWithCallback(options) {
        return new SaveCallbackPackageJsonEditor(options);
    }
    saveIfModified() {
        const modified = super.saveIfModified();
        if (this._onSaved) {
            this._onSaved(this.saveToObject());
        }
        return modified;
    }
}
exports.SaveCallbackPackageJsonEditor = SaveCallbackPackageJsonEditor;
//# sourceMappingURL=SaveCallbackPackageJsonEditor.js.map