import { type ITerminalProvider } from '@rushstack/terminal';
import type { IBuiltInPluginConfiguration } from '../pluginFramework/PluginLoader/BuiltInPluginLoader';
/**
 * Options for RushPnpmCommandLineParser
 */
export interface IRushPnpmCommandLineParserOptions {
    alreadyReportedNodeTooNewError?: boolean;
    builtInPluginConfigurations?: IBuiltInPluginConfiguration[];
    terminalProvider?: ITerminalProvider;
}
export declare class RushPnpmCommandLineParser {
    private readonly _terminal;
    private readonly _rushConfiguration;
    private readonly _pnpmArgs;
    private _commandName;
    private readonly _debugEnabled;
    private _subspace;
    private constructor();
    static initializeAsync(options: IRushPnpmCommandLineParserOptions): Promise<RushPnpmCommandLineParser>;
    executeAsync(): Promise<void>;
    private _validatePnpmUsageAsync;
    private _executeAsync;
    private _postExecuteAsync;
    private _doRushUpdateAsync;
}
//# sourceMappingURL=RushPnpmCommandLineParser.d.ts.map