"use strict";
// Copyright (c) Microsoft Corporation. All rights reserved. Licensed under the MIT license.
// See LICENSE in the project root for license information.
Object.defineProperty(exports, "__esModule", { value: true });
exports.InstallAutoinstallerAction = void 0;
const BaseAutoinstallerAction_1 = require("./BaseAutoinstallerAction");
class InstallAutoinstallerAction extends BaseAutoinstallerAction_1.BaseAutoinstallerAction {
    constructor(parser) {
        super({
            actionName: 'install-autoinstaller',
            summary: 'Install autoinstaller package dependencies',
            documentation: 'Use this command to install dependencies for an autoinstaller folder.',
            parser
        });
    }
    async prepareAsync(autoinstaller) {
        await autoinstaller.prepareAsync();
    }
}
exports.InstallAutoinstallerAction = InstallAutoinstallerAction;
//# sourceMappingURL=InstallAutoinstallerAction.js.map