"use strict";
// Copyright (c) Microsoft Corporation. All rights reserved. Licensed under the MIT license.
// See LICENSE in the project root for license information.
Object.defineProperty(exports, "__esModule", { value: true });
exports.UpdateAutoinstallerAction = void 0;
const BaseAutoinstallerAction_1 = require("./BaseAutoinstallerAction");
class UpdateAutoinstallerAction extends BaseAutoinstallerAction_1.BaseAutoinstallerAction {
    constructor(parser) {
        super({
            actionName: 'update-autoinstaller',
            summary: 'Updates autoinstaller package dependencies',
            documentation: 'Use this command to regenerate the shrinkwrap file for an autoinstaller folder.',
            parser
        });
    }
    async prepareAsync(autoinstaller) {
        // Do not run `autoinstaller.prepareAsync` here. It tries to install the autoinstaller with
        // --frozen-lockfile or equivalent, which will fail if the autoinstaller's dependencies
        // have been changed.
        await autoinstaller.updateAsync();
    }
}
exports.UpdateAutoinstallerAction = UpdateAutoinstallerAction;
//# sourceMappingURL=UpdateAutoinstallerAction.js.map