"use strict";
// Copyright (c) Microsoft Corporation. All rights reserved. Licensed under the MIT license.
// See LICENSE in the project root for license information.
Object.defineProperty(exports, "__esModule", { value: true });
exports.RushLifecycleHooks = exports.RushSession = exports.OperationStatus = exports.Operation = exports.ProjectChangeAnalyzer = exports.CustomTipType = exports.CustomTipSeverity = exports.CustomTipId = exports.CustomTipsConfiguration = exports.ExperimentsConfiguration = exports._RushInternals = exports.Rush = exports.VersionPolicyConfiguration = exports.VersionPolicy = exports.IndividualVersionPolicy = exports.LockStepVersionPolicy = exports.BumpType = exports.VersionPolicyDefinitionName = exports._FlagFile = exports.ChangeManager = exports.Event = exports.EventHooks = exports.RepoStateFile = exports.PackageJsonDependencyMeta = exports.DependencyType = exports.PackageJsonDependency = exports.PackageJsonEditor = exports.CommonVersionsConfiguration = exports.ApprovedPackagesConfiguration = exports.ApprovedPackagesItem = exports._RushGlobalFolder = exports.RushUserConfiguration = exports.RushProjectConfiguration = exports.RushConfigurationProject = exports.PackageManager = exports.RushConstants = exports.EnvironmentVariableNames = exports.EnvironmentConfiguration = exports.FileSystemBuildCacheProvider = exports.CobuildConfiguration = exports.BuildCacheConfiguration = exports.PnpmOptionsConfiguration = exports.YarnOptionsConfiguration = exports.NpmOptionsConfiguration = exports.PackageManagerOptionsConfigurationBase = exports.SubspacesConfiguration = exports.Subspace = exports.RushConfiguration = exports.ApprovedPackagesPolicy = exports.LookupByPath = void 0;
exports._OperationBuildCache = exports.RushCommandLine = exports._OperationMetadataManager = exports._OperationStateFile = exports.CredentialCache = exports.PhasedCommandHooks = void 0;
/// <reference types="node" preserve="true" />
/**
 * A library for writing scripts that interact with the {@link https://rushjs.io/ | Rush} tool.
 * @packageDocumentation
 */
// For backwards compatibility
var lookup_by_path_1 = require("@rushstack/lookup-by-path");
Object.defineProperty(exports, "LookupByPath", { enumerable: true, get: function () { return lookup_by_path_1.LookupByPath; } });
var ApprovedPackagesPolicy_1 = require("./api/ApprovedPackagesPolicy");
Object.defineProperty(exports, "ApprovedPackagesPolicy", { enumerable: true, get: function () { return ApprovedPackagesPolicy_1.ApprovedPackagesPolicy; } });
var RushConfiguration_1 = require("./api/RushConfiguration");
Object.defineProperty(exports, "RushConfiguration", { enumerable: true, get: function () { return RushConfiguration_1.RushConfiguration; } });
var Subspace_1 = require("./api/Subspace");
Object.defineProperty(exports, "Subspace", { enumerable: true, get: function () { return Subspace_1.Subspace; } });
var SubspacesConfiguration_1 = require("./api/SubspacesConfiguration");
Object.defineProperty(exports, "SubspacesConfiguration", { enumerable: true, get: function () { return SubspacesConfiguration_1.SubspacesConfiguration; } });
var BasePackageManagerOptionsConfiguration_1 = require("./logic/base/BasePackageManagerOptionsConfiguration");
Object.defineProperty(exports, "PackageManagerOptionsConfigurationBase", { enumerable: true, get: function () { return BasePackageManagerOptionsConfiguration_1.PackageManagerOptionsConfigurationBase; } });
var NpmOptionsConfiguration_1 = require("./logic/npm/NpmOptionsConfiguration");
Object.defineProperty(exports, "NpmOptionsConfiguration", { enumerable: true, get: function () { return NpmOptionsConfiguration_1.NpmOptionsConfiguration; } });
var YarnOptionsConfiguration_1 = require("./logic/yarn/YarnOptionsConfiguration");
Object.defineProperty(exports, "YarnOptionsConfiguration", { enumerable: true, get: function () { return YarnOptionsConfiguration_1.YarnOptionsConfiguration; } });
var PnpmOptionsConfiguration_1 = require("./logic/pnpm/PnpmOptionsConfiguration");
Object.defineProperty(exports, "PnpmOptionsConfiguration", { enumerable: true, get: function () { return PnpmOptionsConfiguration_1.PnpmOptionsConfiguration; } });
var BuildCacheConfiguration_1 = require("./api/BuildCacheConfiguration");
Object.defineProperty(exports, "BuildCacheConfiguration", { enumerable: true, get: function () { return BuildCacheConfiguration_1.BuildCacheConfiguration; } });
var CobuildConfiguration_1 = require("./api/CobuildConfiguration");
Object.defineProperty(exports, "CobuildConfiguration", { enumerable: true, get: function () { return CobuildConfiguration_1.CobuildConfiguration; } });
var FileSystemBuildCacheProvider_1 = require("./logic/buildCache/FileSystemBuildCacheProvider");
Object.defineProperty(exports, "FileSystemBuildCacheProvider", { enumerable: true, get: function () { return FileSystemBuildCacheProvider_1.FileSystemBuildCacheProvider; } });
var EnvironmentConfiguration_1 = require("./api/EnvironmentConfiguration");
Object.defineProperty(exports, "EnvironmentConfiguration", { enumerable: true, get: function () { return EnvironmentConfiguration_1.EnvironmentConfiguration; } });
Object.defineProperty(exports, "EnvironmentVariableNames", { enumerable: true, get: function () { return EnvironmentConfiguration_1.EnvironmentVariableNames; } });
var RushConstants_1 = require("./logic/RushConstants");
Object.defineProperty(exports, "RushConstants", { enumerable: true, get: function () { return RushConstants_1.RushConstants; } });
var PackageManager_1 = require("./api/packageManager/PackageManager");
Object.defineProperty(exports, "PackageManager", { enumerable: true, get: function () { return PackageManager_1.PackageManager; } });
var RushConfigurationProject_1 = require("./api/RushConfigurationProject");
Object.defineProperty(exports, "RushConfigurationProject", { enumerable: true, get: function () { return RushConfigurationProject_1.RushConfigurationProject; } });
var RushProjectConfiguration_1 = require("./api/RushProjectConfiguration");
Object.defineProperty(exports, "RushProjectConfiguration", { enumerable: true, get: function () { return RushProjectConfiguration_1.RushProjectConfiguration; } });
var RushUserConfiguration_1 = require("./api/RushUserConfiguration");
Object.defineProperty(exports, "RushUserConfiguration", { enumerable: true, get: function () { return RushUserConfiguration_1.RushUserConfiguration; } });
var RushGlobalFolder_1 = require("./api/RushGlobalFolder");
Object.defineProperty(exports, "_RushGlobalFolder", { enumerable: true, get: function () { return RushGlobalFolder_1.RushGlobalFolder; } });
var ApprovedPackagesConfiguration_1 = require("./api/ApprovedPackagesConfiguration");
Object.defineProperty(exports, "ApprovedPackagesItem", { enumerable: true, get: function () { return ApprovedPackagesConfiguration_1.ApprovedPackagesItem; } });
Object.defineProperty(exports, "ApprovedPackagesConfiguration", { enumerable: true, get: function () { return ApprovedPackagesConfiguration_1.ApprovedPackagesConfiguration; } });
var CommonVersionsConfiguration_1 = require("./api/CommonVersionsConfiguration");
Object.defineProperty(exports, "CommonVersionsConfiguration", { enumerable: true, get: function () { return CommonVersionsConfiguration_1.CommonVersionsConfiguration; } });
var PackageJsonEditor_1 = require("./api/PackageJsonEditor");
Object.defineProperty(exports, "PackageJsonEditor", { enumerable: true, get: function () { return PackageJsonEditor_1.PackageJsonEditor; } });
Object.defineProperty(exports, "PackageJsonDependency", { enumerable: true, get: function () { return PackageJsonEditor_1.PackageJsonDependency; } });
Object.defineProperty(exports, "DependencyType", { enumerable: true, get: function () { return PackageJsonEditor_1.DependencyType; } });
Object.defineProperty(exports, "PackageJsonDependencyMeta", { enumerable: true, get: function () { return PackageJsonEditor_1.PackageJsonDependencyMeta; } });
var RepoStateFile_1 = require("./logic/RepoStateFile");
Object.defineProperty(exports, "RepoStateFile", { enumerable: true, get: function () { return RepoStateFile_1.RepoStateFile; } });
var EventHooks_1 = require("./api/EventHooks");
Object.defineProperty(exports, "EventHooks", { enumerable: true, get: function () { return EventHooks_1.EventHooks; } });
Object.defineProperty(exports, "Event", { enumerable: true, get: function () { return EventHooks_1.Event; } });
var ChangeManager_1 = require("./api/ChangeManager");
Object.defineProperty(exports, "ChangeManager", { enumerable: true, get: function () { return ChangeManager_1.ChangeManager; } });
var FlagFile_1 = require("./api/FlagFile");
Object.defineProperty(exports, "_FlagFile", { enumerable: true, get: function () { return FlagFile_1.FlagFile; } });
var VersionPolicy_1 = require("./api/VersionPolicy");
Object.defineProperty(exports, "VersionPolicyDefinitionName", { enumerable: true, get: function () { return VersionPolicy_1.VersionPolicyDefinitionName; } });
Object.defineProperty(exports, "BumpType", { enumerable: true, get: function () { return VersionPolicy_1.BumpType; } });
Object.defineProperty(exports, "LockStepVersionPolicy", { enumerable: true, get: function () { return VersionPolicy_1.LockStepVersionPolicy; } });
Object.defineProperty(exports, "IndividualVersionPolicy", { enumerable: true, get: function () { return VersionPolicy_1.IndividualVersionPolicy; } });
Object.defineProperty(exports, "VersionPolicy", { enumerable: true, get: function () { return VersionPolicy_1.VersionPolicy; } });
var VersionPolicyConfiguration_1 = require("./api/VersionPolicyConfiguration");
Object.defineProperty(exports, "VersionPolicyConfiguration", { enumerable: true, get: function () { return VersionPolicyConfiguration_1.VersionPolicyConfiguration; } });
var Rush_1 = require("./api/Rush");
Object.defineProperty(exports, "Rush", { enumerable: true, get: function () { return Rush_1.Rush; } });
var RushInternals_1 = require("./api/RushInternals");
Object.defineProperty(exports, "_RushInternals", { enumerable: true, get: function () { return RushInternals_1.RushInternals; } });
var ExperimentsConfiguration_1 = require("./api/ExperimentsConfiguration");
Object.defineProperty(exports, "ExperimentsConfiguration", { enumerable: true, get: function () { return ExperimentsConfiguration_1.ExperimentsConfiguration; } });
var CustomTipsConfiguration_1 = require("./api/CustomTipsConfiguration");
Object.defineProperty(exports, "CustomTipsConfiguration", { enumerable: true, get: function () { return CustomTipsConfiguration_1.CustomTipsConfiguration; } });
Object.defineProperty(exports, "CustomTipId", { enumerable: true, get: function () { return CustomTipsConfiguration_1.CustomTipId; } });
Object.defineProperty(exports, "CustomTipSeverity", { enumerable: true, get: function () { return CustomTipsConfiguration_1.CustomTipSeverity; } });
Object.defineProperty(exports, "CustomTipType", { enumerable: true, get: function () { return CustomTipsConfiguration_1.CustomTipType; } });
var ProjectChangeAnalyzer_1 = require("./logic/ProjectChangeAnalyzer");
Object.defineProperty(exports, "ProjectChangeAnalyzer", { enumerable: true, get: function () { return ProjectChangeAnalyzer_1.ProjectChangeAnalyzer; } });
var Operation_1 = require("./logic/operations/Operation");
Object.defineProperty(exports, "Operation", { enumerable: true, get: function () { return Operation_1.Operation; } });
var OperationStatus_1 = require("./logic/operations/OperationStatus");
Object.defineProperty(exports, "OperationStatus", { enumerable: true, get: function () { return OperationStatus_1.OperationStatus; } });
var RushSession_1 = require("./pluginFramework/RushSession");
Object.defineProperty(exports, "RushSession", { enumerable: true, get: function () { return RushSession_1.RushSession; } });
var RushLifeCycle_1 = require("./pluginFramework/RushLifeCycle");
Object.defineProperty(exports, "RushLifecycleHooks", { enumerable: true, get: function () { return RushLifeCycle_1.RushLifecycleHooks; } });
var PhasedCommandHooks_1 = require("./pluginFramework/PhasedCommandHooks");
Object.defineProperty(exports, "PhasedCommandHooks", { enumerable: true, get: function () { return PhasedCommandHooks_1.PhasedCommandHooks; } });
var CredentialCache_1 = require("./logic/CredentialCache");
Object.defineProperty(exports, "CredentialCache", { enumerable: true, get: function () { return CredentialCache_1.CredentialCache; } });
var OperationStateFile_1 = require("./logic/operations/OperationStateFile");
Object.defineProperty(exports, "_OperationStateFile", { enumerable: true, get: function () { return OperationStateFile_1.OperationStateFile; } });
var OperationMetadataManager_1 = require("./logic/operations/OperationMetadataManager");
Object.defineProperty(exports, "_OperationMetadataManager", { enumerable: true, get: function () { return OperationMetadataManager_1.OperationMetadataManager; } });
var RushCommandLine_1 = require("./api/RushCommandLine");
Object.defineProperty(exports, "RushCommandLine", { enumerable: true, get: function () { return RushCommandLine_1.RushCommandLine; } });
var OperationBuildCache_1 = require("./logic/buildCache/OperationBuildCache");
Object.defineProperty(exports, "_OperationBuildCache", { enumerable: true, get: function () { return OperationBuildCache_1.OperationBuildCache; } });
//# sourceMappingURL=index.js.map