/**
 * Options for generating the cache id for an operation.
 * @beta
 */
export interface IGenerateCacheEntryIdOptions {
    /**
     * The name of the project
     */
    projectName: string;
    /**
     * The name of the phase
     */
    phaseName: string;
    /**
     * A hash of the input files
     */
    projectStateHash: string;
}
/**
 * Calculates the cache entry id string for an operation.
 * @beta
 */
export type GetCacheEntryIdFunction = (options: IGenerateCacheEntryIdOptions) => string;
export declare class CacheEntryId {
    private constructor();
    static parsePattern(pattern?: string): GetCacheEntryIdFunction;
}
//# sourceMappingURL=CacheEntryId.d.ts.map