import { type ITerminal } from '@rushstack/terminal';
import type { RushConfiguration } from '../../api/RushConfiguration';
import type { RushGlobalFolder } from '../../api/RushGlobalFolder';
import type { Subspace } from '../../api/Subspace';
export declare class InstallHelpers {
    static generateCommonPackageJson(rushConfiguration: RushConfiguration, subspace: Subspace, dependencies: Map<string, string> | undefined, terminal: ITerminal): void;
    static getPackageManagerEnvironment(rushConfiguration: RushConfiguration, options?: {
        debug?: boolean;
    }): NodeJS.ProcessEnv;
    /**
     * If the "(p)npm-local" symlink hasn't been set up yet, this creates it, installing the
     * specified (P)npm version in the user's home directory if needed.
     */
    static ensureLocalPackageManagerAsync(rushConfiguration: RushConfiguration, rushGlobalFolder: RushGlobalFolder, maxInstallAttempts: number, restrictConsoleOutput?: boolean): Promise<void>;
    private static _mergeEnvironmentVariables;
}
//# sourceMappingURL=InstallHelpers.d.ts.map