import type { ITerminal } from '@rushstack/terminal';
import type { IPhasedCommandPlugin, PhasedCommandHooks } from '../../pluginFramework/PhasedCommandHooks';
import type { IExecutionResult } from './IOperationExecutionResult';
import type { CobuildConfiguration } from '../../api/CobuildConfiguration';
/**
 * Phased command plugin that emits a timeline to the console.
 */
export declare class ConsoleTimelinePlugin implements IPhasedCommandPlugin {
    private readonly _terminal;
    constructor(terminal: ITerminal);
    apply(hooks: PhasedCommandHooks): void;
}
/**
 * @internal
 */
export interface IPrintTimelineParameters {
    terminal: ITerminal;
    result: IExecutionResult;
    cobuildConfiguration?: CobuildConfiguration;
}
/**
 * Print a more detailed timeline and analysis of CPU usage for the build.
 * @internal
 */
export declare function _printTimeline({ terminal, result }: IPrintTimelineParameters): void;
//# sourceMappingURL=ConsoleTimelinePlugin.d.ts.map