import { type ITerminal } from '@rushstack/terminal';
import type { IPhasedCommandPlugin, PhasedCommandHooks } from '../../pluginFramework/PhasedCommandHooks';
export interface IProjectDeps {
    files: {
        [filePath: string]: string;
    };
    arguments: string;
}
export interface ILegacySkipPluginOptions {
    terminal: ITerminal;
    changedProjectsOnly: boolean;
    isIncrementalBuildAllowed: boolean;
    allowWarningsInSuccessfulBuild?: boolean;
}
/**
 * Core phased command plugin that implements the legacy skip detection logic, used when build cache is disabled.
 */
export declare class LegacySkipPlugin implements IPhasedCommandPlugin {
    private readonly _options;
    constructor(options: ILegacySkipPluginOptions);
    apply(hooks: PhasedCommandHooks): void;
}
//# sourceMappingURL=LegacySkipPlugin.d.ts.map