import { type ITerminal } from '@rushstack/terminal';
import type { IPhasedCommandPlugin, PhasedCommandHooks } from '../../pluginFramework/PhasedCommandHooks';
import type { IExecutionResult } from './IOperationExecutionResult';
/**
 * Phased command plugin that emits a summary of build results to the console.
 */
export declare class OperationResultSummarizerPlugin implements IPhasedCommandPlugin {
    private readonly _terminal;
    constructor(terminal: ITerminal);
    apply(hooks: PhasedCommandHooks): void;
}
/**
 * Prints out a report of the status of each project
 * @internal
 */
export declare function _printOperationStatus(terminal: ITerminal, result: IExecutionResult): void;
//# sourceMappingURL=OperationResultSummarizerPlugin.d.ts.map