import { type IPackageJson } from '@rushstack/node-core-library';
import type { RushConfiguration } from '../../api/RushConfiguration';
import type { Subspace } from '../../api/Subspace';
/**
 * Loads PNPM's pnpmfile.js configuration, and invokes it to preprocess package.json files,
 * optionally utilizing a pnpmfile shim to inject preferred versions.
 */
export declare class PnpmfileConfiguration {
    private _context;
    private constructor();
    static initializeAsync(rushConfiguration: RushConfiguration, subspace: Subspace, variant: string | undefined): Promise<PnpmfileConfiguration>;
    static writeCommonTempPnpmfileShimAsync(rushConfiguration: RushConfiguration, targetDir: string, subspace: Subspace, variant: string | undefined): Promise<void>;
    private static _getPnpmfileShimSettingsAsync;
    /**
     * Transform a package.json file using the pnpmfile.js hook.
     * @returns the transformed object, or the original input if pnpmfile.js was not found.
     */
    transform(packageJson: IPackageJson): IPackageJson;
}
//# sourceMappingURL=PnpmfileConfiguration.d.ts.map