"use strict";
// Copyright (c) Microsoft Corporation. All rights reserved. Licensed under the MIT license.
// See LICENSE in the project root for license information.
Object.defineProperty(exports, "__esModule", { value: true });
exports.SubspaceSelectorParser = void 0;
const RushConstants_1 = require("../RushConstants");
class SubspaceSelectorParser {
    constructor(rushConfiguration) {
        this._rushConfiguration = rushConfiguration;
    }
    async evaluateSelectorAsync({ unscopedSelector }) {
        const subspace = this._rushConfiguration.getSubspace(unscopedSelector);
        return subspace.getProjects();
    }
    getCompletions() {
        // Tab completion is a performance sensitive operation, so avoid loading all the projects
        const subspaceNames = [];
        if (this._rushConfiguration.subspacesConfiguration) {
            subspaceNames.push(...this._rushConfiguration.subspacesConfiguration.subspaceNames);
        }
        if (!subspaceNames.indexOf(RushConstants_1.RushConstants.defaultSubspaceName)) {
            subspaceNames.push(RushConstants_1.RushConstants.defaultSubspaceName);
        }
        return subspaceNames;
    }
}
exports.SubspaceSelectorParser = SubspaceSelectorParser;
//# sourceMappingURL=SubspaceSelectorParser.js.map