"use strict";
// Copyright (c) Microsoft Corporation. All rights reserved. Licensed under the MIT license.
// See LICENSE in the project root for license information.
Object.defineProperty(exports, "__esModule", { value: true });
exports.TagProjectSelectorParser = void 0;
const node_core_library_1 = require("@rushstack/node-core-library");
const RushConstants_1 = require("../RushConstants");
class TagProjectSelectorParser {
    constructor(rushConfiguration) {
        this._rushConfiguration = rushConfiguration;
    }
    async evaluateSelectorAsync({ unscopedSelector, terminal, parameterName }) {
        const selection = this._rushConfiguration.projectsByTag.get(unscopedSelector);
        if (!selection) {
            terminal.writeErrorLine(`The tag "${unscopedSelector}" passed to "${parameterName}" is not specified for any projects in ` +
                `${RushConstants_1.RushConstants.rushJsonFilename}.`);
            throw new node_core_library_1.AlreadyReportedError();
        }
        return selection;
    }
    getCompletions() {
        return this._rushConfiguration.projectsByTag.keys();
    }
}
exports.TagProjectSelectorParser = TagProjectSelectorParser;
//# sourceMappingURL=TagProjectSelectorParser.js.map