// Copyright (c) Microsoft Corporation. All rights reserved. Licensed under the MIT license.
// See LICENSE in the project root for license information.
import { FileSystem, JsonFile, JsonSchema } from '@rushstack/node-core-library';
import schemaJson from '../schemas/rush-plugins.schema.json';
export class RushPluginsConfiguration {
    constructor(jsonFilename) {
        this._jsonFilename = jsonFilename;
        this.configuration = {
            plugins: []
        };
        if (FileSystem.exists(this._jsonFilename)) {
            this.configuration = JsonFile.loadAndValidate(this._jsonFilename, RushPluginsConfiguration._jsonSchema);
        }
    }
}
RushPluginsConfiguration._jsonSchema = JsonSchema.fromLoadedObject(schemaJson);
//# sourceMappingURL=RushPluginsConfiguration.js.map