// Copyright (c) Microsoft Corporation. All rights reserved. Licensed under the MIT license.
// See LICENSE in the project root for license information.
import { PackageJsonEditor } from './PackageJsonEditor';
export class SaveCallbackPackageJsonEditor extends PackageJsonEditor {
    constructor(options) {
        super(options.filename, options.object);
        this._onSaved = options.onSaved;
    }
    static fromObjectWithCallback(options) {
        return new SaveCallbackPackageJsonEditor(options);
    }
    saveIfModified() {
        const modified = super.saveIfModified();
        if (this._onSaved) {
            this._onSaved(this.saveToObject());
        }
        return modified;
    }
}
//# sourceMappingURL=SaveCallbackPackageJsonEditor.js.map