// Copyright (c) Microsoft Corporation. All rights reserved. Licensed under the MIT license.
// See LICENSE in the project root for license information.
import { BaseAutoinstallerAction } from './BaseAutoinstallerAction';
export class InstallAutoinstallerAction extends BaseAutoinstallerAction {
    constructor(parser) {
        super({
            actionName: 'install-autoinstaller',
            summary: 'Install autoinstaller package dependencies',
            documentation: 'Use this command to install dependencies for an autoinstaller folder.',
            parser
        });
    }
    async prepareAsync(autoinstaller) {
        await autoinstaller.prepareAsync();
    }
}
//# sourceMappingURL=InstallAutoinstallerAction.js.map