// Copyright (c) Microsoft Corporation. All rights reserved. Licensed under the MIT license.
// See LICENSE in the project root for license information.
import { RushConstants } from '../RushConstants';
export class SubspaceSelectorParser {
    constructor(rushConfiguration) {
        this._rushConfiguration = rushConfiguration;
    }
    async evaluateSelectorAsync({ unscopedSelector }) {
        const subspace = this._rushConfiguration.getSubspace(unscopedSelector);
        return subspace.getProjects();
    }
    getCompletions() {
        // Tab completion is a performance sensitive operation, so avoid loading all the projects
        const subspaceNames = [];
        if (this._rushConfiguration.subspacesConfiguration) {
            subspaceNames.push(...this._rushConfiguration.subspacesConfiguration.subspaceNames);
        }
        if (!subspaceNames.indexOf(RushConstants.defaultSubspaceName)) {
            subspaceNames.push(RushConstants.defaultSubspaceName);
        }
        return subspaceNames;
    }
}
//# sourceMappingURL=SubspaceSelectorParser.js.map