// Copyright (c) Microsoft Corporation. All rights reserved. Licensed under the MIT license.
// See LICENSE in the project root for license information.
import { AlreadyReportedError } from '@rushstack/node-core-library';
import { RushConstants } from '../RushConstants';
export class TagProjectSelectorParser {
    constructor(rushConfiguration) {
        this._rushConfiguration = rushConfiguration;
    }
    async evaluateSelectorAsync({ unscopedSelector, terminal, parameterName }) {
        const selection = this._rushConfiguration.projectsByTag.get(unscopedSelector);
        if (!selection) {
            terminal.writeErrorLine(`The tag "${unscopedSelector}" passed to "${parameterName}" is not specified for any projects in ` +
                `${RushConstants.rushJsonFilename}.`);
            throw new AlreadyReportedError();
        }
        return selection;
    }
    getCompletions() {
        return this._rushConfiguration.projectsByTag.keys();
    }
}
//# sourceMappingURL=TagProjectSelectorParser.js.map