import type { RushConfiguration } from '../api/RushConfiguration';
import type { RushGlobalFolder } from '../api/RushGlobalFolder';
export interface IAutoinstallerOptions {
    autoinstallerName: string;
    rushConfiguration: RushConfiguration;
    rushGlobalFolder: RushGlobalFolder;
    restrictConsoleOutput?: boolean;
}
export declare class Autoinstaller {
    readonly name: string;
    private readonly _rushConfiguration;
    private readonly _rushGlobalFolder;
    private readonly _restrictConsoleOutput;
    constructor(options: IAutoinstallerOptions);
    get folderFullPath(): string;
    get shrinkwrapFilePath(): string;
    get packageJsonPath(): string;
    static validateName(autoinstallerName: string): void;
    prepareAsync(): Promise<void>;
    updateAsync(): Promise<void>;
    private _logIfConsoleOutputIsNotRestricted;
}
//# sourceMappingURL=Autoinstaller.d.ts.map