/**
 * @beta
 */
export interface ICredentialCacheEntry {
    expires?: Date;
    credential: string;
    credentialMetadata?: object;
}
/**
 * @beta
 */
export interface ICredentialCacheOptions {
    supportEditing: boolean;
    /**
     * If specified, use the specified path instead of the default path of `~/.rush-user/credentials.json`
     */
    cacheFilePath?: string;
}
/**
 * @beta
 */
export declare class CredentialCache {
    private readonly _cacheFilePath;
    private readonly _cacheEntries;
    private _modified;
    private _disposed;
    private _supportsEditing;
    private readonly _lockfile;
    private constructor();
    static initializeAsync(options: ICredentialCacheOptions): Promise<CredentialCache>;
    static usingAsync(options: ICredentialCacheOptions, doActionAsync: (credentialCache: CredentialCache) => Promise<void> | void): Promise<void>;
    setCacheEntry(cacheId: string, entry: ICredentialCacheEntry): void;
    tryGetCacheEntry(cacheId: string): ICredentialCacheEntry | undefined;
    deleteCacheEntry(cacheId: string): void;
    trimExpiredEntries(): void;
    saveIfModifiedAsync(): Promise<void>;
    dispose(): void;
    private _validate;
}
//# sourceMappingURL=CredentialCache.d.ts.map