import type { RushConfiguration } from '../api/RushConfiguration';
/**
 * Validate that the developer's setup is good.
 *
 * These checks are invoked prior to the following commands:
 * - rush install
 * - rush update
 * - rush build
 * - rush rebuild
 */
export declare class SetupChecks {
    static validate(rushConfiguration: RushConfiguration): void;
    private static _validate;
    private static _checkForPhantomFolders;
    /**
     * Checks "folder" and each of its parents to see if it contains a node_modules folder.
     * The bad folders will be added to phantomFolders.
     * The seenFolders set is used to avoid duplicates.
     */
    private static _collectPhantomFoldersUpwards;
}
//# sourceMappingURL=SetupChecks.d.ts.map