import type { ITerminal } from '@rushstack/terminal';
/**
 * @beta
 */
export interface ICloudBuildCacheProvider {
    readonly isCacheWriteAllowed: boolean;
    tryGetCacheEntryBufferByIdAsync(terminal: ITerminal, cacheId: string): Promise<Buffer | undefined>;
    trySetCacheEntryBufferAsync(terminal: ITerminal, cacheId: string, entryBuffer: Buffer): Promise<boolean>;
    updateCachedCredentialAsync(terminal: ITerminal, credential: string): Promise<void>;
    updateCachedCredentialInteractiveAsync(terminal: ITerminal): Promise<void>;
    deleteCachedCredentialsAsync(terminal: ITerminal): Promise<void>;
}
//# sourceMappingURL=ICloudBuildCacheProvider.d.ts.map