export type ICallbackFn = () => Promise<void> | void;
export interface IPeriodicCallbackOptions {
    interval: number;
}
/**
 * A help class to run callbacks in a loop with a specified interval.
 *
 * @beta
 */
export declare class PeriodicCallback {
    private _callbacks;
    private _interval;
    private _intervalId;
    private _isRunning;
    constructor(options: IPeriodicCallbackOptions);
    addCallback(callback: ICallbackFn): void;
    start(): void;
    stop(): void;
}
//# sourceMappingURL=PeriodicCallback.d.ts.map