import { BaseProjectShrinkwrapFile } from '../base/BaseProjectShrinkwrapFile';
import type { PnpmShrinkwrapFile } from './PnpmShrinkwrapFile';
/**
 *
 */
export declare class PnpmProjectShrinkwrapFile extends BaseProjectShrinkwrapFile<PnpmShrinkwrapFile> {
    /**
     * Generate and write the project shrinkwrap file to <project>/.rush/temp/shrinkwrap-deps.json.
     * @returns True if the project shrinkwrap was created or updated, false otherwise.
     */
    updateProjectShrinkwrapAsync(): Promise<void>;
    hasChanges(otherShrinkwrap: PnpmProjectShrinkwrapFile): boolean;
    /**
     * Generate the project shrinkwrap file content
     */
    protected generateProjectShrinkwrapMap(): Map<string, string> | undefined;
    protected generateWorkspaceProjectShrinkwrapMap(): Map<string, string> | undefined;
    protected generateLegacyProjectShrinkwrapMap(): Map<string, string>;
    private _addDependencyRecursive;
    private _resolveAndAddPeerDependencies;
    /**
     * Save the current state of the object to project/.rush/temp/shrinkwrap-deps.json
     */
    protected saveAsync(projectShrinkwrapMap: Map<string, string>): Promise<void>;
}
//# sourceMappingURL=PnpmProjectShrinkwrapFile.d.ts.map