export interface IArtifactoryPackageRegistryJson {
    enabled: boolean;
    userNpmrcLinesToAdd?: string[];
    registryUrl: string;
    artifactoryWebsiteUrl: string;
    credentialType?: 'password' | 'authToken';
    messageOverrides?: {
        introduction?: string;
        obtainAnAccount?: string;
        visitWebsite?: string;
        locateUserName?: string;
        locateApiKey?: string;
    };
}
/**
 * This interface represents the raw artifactory.json file.
 * @beta
 */
export interface IArtifactoryJson {
    packageRegistry: IArtifactoryPackageRegistryJson;
}
/**
 * Use this class to load the "common/config/rush/artifactory.json" config file.
 * It configures the "rush setup" command.
 */
export declare class ArtifactoryConfiguration {
    private static _jsonSchema;
    private readonly _jsonFileName;
    /**
     * Get the artifactory configuration.
     */
    readonly configuration: Readonly<IArtifactoryJson>;
    /**
     * @internal
     */
    constructor(jsonFileName: string);
}
//# sourceMappingURL=ArtifactoryConfiguration.d.ts.map