import { type JsonObject } from '@rushstack/node-core-library';
import type { IRushPluginConfiguration } from '../../api/RushPluginsConfiguration';
import { Autoinstaller } from '../../logic/Autoinstaller';
import { type IPluginLoaderOptions, PluginLoaderBase } from './PluginLoaderBase';
import type { RushGlobalFolder } from '../../api/RushGlobalFolder';
interface IAutoinstallerPluginLoaderOptions extends IPluginLoaderOptions<IRushPluginConfiguration> {
    restrictConsoleOutput: boolean;
    rushGlobalFolder: RushGlobalFolder;
}
/**
 * @beta
 */
export declare class AutoinstallerPluginLoader extends PluginLoaderBase<IRushPluginConfiguration> {
    readonly packageFolder: string;
    readonly autoinstaller: Autoinstaller;
    constructor(options: IAutoinstallerPluginLoaderOptions);
    /**
     * The folder where rush plugins static files are stored.
     * Example: `C:\MyRepo\common\autoinstallers\<autoinstaller_name>\rush-plugins`
     */
    static getPluginAutoinstallerStorePath(autoinstaller: Autoinstaller): string;
    update(): void;
    protected _getCommandLineAdditionalPathFolders(): string[];
    protected _getPluginOptions(): JsonObject;
    protected _getManifestPath(): string;
    protected _getCommandLineJsonFilePath(): string;
}
export {};
//# sourceMappingURL=AutoinstallerPluginLoader.d.ts.map