import { type ITerminal } from '@rushstack/terminal';
import type { RushConfiguration } from '../api/RushConfiguration';
import type { RushConfigurationProject } from '../api/RushConfigurationProject';
import type { Subspace } from '../api/Subspace';
export declare class HotlinkManager {
    private _linksBySubspaceName;
    private readonly _rushLinkStateFilePath;
    private constructor();
    hasAnyHotlinksInSubspace(subspaceName: string): boolean;
    private _hardLinkToLinkedPackageAsync;
    private _modifyAndSaveLinkStateAsync;
    purgeLinksAsync(terminal: ITerminal, subspaceName: string): Promise<boolean>;
    private _getLinkedPackageInfoAsync;
    private _getPackagePathsMatchingNameAndVersionAsync;
    bridgePackageAsync(terminal: ITerminal, subspace: Subspace, linkedPackagePath: string, version: string): Promise<void>;
    linkPackageAsync(terminal: ITerminal, consumerPackage: RushConfigurationProject, linkedPackagePath: string): Promise<void>;
    static loadFromRushConfiguration(rushConfiguration: RushConfiguration): HotlinkManager;
}
//# sourceMappingURL=HotlinkManager.d.ts.map